
+function($){'use strict';var Tab=function(element){this.element=$(element)}
Tab.VERSION='3.3.6'
Tab.TRANSITION_DURATION=150
Tab.prototype.show=function(){var $this=this.element
var $ul=$this.closest('ul:not(.dropdown-menu)')
var selector=$this.data('target')
if(!selector){selector=$this.attr('href')
selector=selector&&selector.replace(/.*(?=#[^\s]*$)/,'')}
if($this.parent('li').hasClass('active'))return
var $previous=$ul.find('.active:last a')
var hideEvent=$.Event('hide.bs.tab',{relatedTarget:$this[0]})
var showEvent=$.Event('show.bs.tab',{relatedTarget:$previous[0]})
$previous.trigger(hideEvent)
$this.trigger(showEvent)
if(showEvent.isDefaultPrevented()||hideEvent.isDefaultPrevented())return
var $target=$(selector)
this.activate($this.closest('li'),$ul)
this.activate($target,$target.parent(),function(){$previous.trigger({type:'hidden.bs.tab',relatedTarget:$this[0]})
$this.trigger({type:'shown.bs.tab',relatedTarget:$previous[0]})})}
Tab.prototype.activate=function(element,container,callback){var $active=container.find('> .active')
var transition=callback&&$.support.transition&&($active.length&&$active.hasClass('fade')||!!container.find('> .fade').length)
function next(){$active.removeClass('active').find('> .dropdown-menu > .active').removeClass('active').end().find('[data-toggle="tab"]').attr('aria-expanded',false)
element.addClass('active').find('[data-toggle="tab"]').attr('aria-expanded',true)
if(transition){element[0].offsetWidth
element.addClass('in')}else{element.removeClass('fade')}
if(element.parent('.dropdown-menu').length){element.closest('li.dropdown').addClass('active').end().find('[data-toggle="tab"]').attr('aria-expanded',true)}
callback&&callback()}
$active.length&&transition?$active.one('bsTransitionEnd',next).emulateTransitionEnd(Tab.TRANSITION_DURATION):next()
$active.removeClass('in')}
function Plugin(option){return this.each(function(){var $this=$(this)
var data=$this.data('bs.tab')
if(!data)$this.data('bs.tab',(data=new Tab(this)))
if(typeof option=='string')data[option]()})}
var old=$.fn.tab
$.fn.tab=Plugin
$.fn.tab.Constructor=Tab
$.fn.tab.noConflict=function(){$.fn.tab=old
return this}
var clickHandler=function(e){e.preventDefault()
Plugin.call($(this),'show')}
$(document).on('click.bs.tab.data-api','[data-toggle="tab"]',clickHandler).on('click.bs.tab.data-api','[data-toggle="pill"]',clickHandler)}(jQuery);define('barclays/mca/components/templates/bdl/tab/mca-tab',function(){return function anonymous(locals,escape,include,rethrow){rethrow=rethrow||function rethrow(err,str,filename,lineno){var lines=str.split('\n');var start=Math.max(lineno-3,0);var end=Math.min(lines.length,lineno+3);var context=lines.slice(start,end).map(function(line,i){var curr=i+start+1;return(curr==lineno?' >> ':'    ')
+curr
+'| '
+line;}).join('\n');err.path=filename;err.message=(filename||'ejs')+':'
+lineno+'\n'
+context+'\n\n'
+err.message;throw err;};escape=escape||function(markup){return markup==undefined?'':String(markup).replace(_MATCH_HTML,encode_char);};var _ENCODE_HTML_RULES={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&#34;","'":"&#39;"},_MATCH_HTML=/[&<>'"]/g;function encode_char(c){return _ENCODE_HTML_RULES[c]||c;};;var __line=1,__lines="<div id=\"<%= model.id %>\" role=\"tabpanel\" class=\"tabbed-content <%= ' ' %> <%= model.tabContentState %> <%= ' ' %>  <%= model['class'] %>\" tabindex=\"<%= parseInt(model.tabindex) || 0 %>\">\n<% if (model.name.length > 0 ) { %>\n<mca-link id=\"<%= model.id %>__tab\" type=\"paragraph\" class=\"<%= model.tabContentState %> tab\" icon=\"<%= model.icon %>\" onload=\"<%= model.linkbindlistner %>\">\n<%= model.name %>\n</mca-link>\n<% } %>\n<%- model.content %>\n</div>",__filename=undefined;try{var __output=[],__append=__output.push.bind(__output);with(locals||{}){;__append("<div id=\"");__append(escape(model.id));__append("\" role=\"tabpanel\" class=\"tabbed-content ");__append(escape(' '));__append(" ");__append(escape(model.tabContentState));__append(" ");__append(escape(' '));__append("  ");__append(escape(model['class']));__append("\" tabindex=\"");__append(escape(parseInt(model.tabindex)||0));__append("\">\n");__line=2;if(model.name.length>0){;__append("<mca-link id=\"");__line=3;__append(escape(model.id));__append("__tab\" type=\"paragraph\" class=\"");__append(escape(model.tabContentState));__append(" tab\" icon=\"");__append(escape(model.icon));__append("\" onload=\"");__append(escape(model.linkbindlistner));__append("\">\n");__line=4;__append(escape(model.name));__append("</mca-link>\n");__line=6;};__line=7;__append(model.content);__append("</div>");__line=8}
return __output.join("");}catch(e){rethrow(e,__lines,__filename,__line);}}});define('barclays/mca/components/collection/bdl/tab',['barclays/mca/components/libs/common/extend/bdlApi','barclays/mca/components/collection/bdl/icon'],function(api,icon){var definition=api.createComponent('tab');definition.usePrebuiltBdlStyles();definition.declareBehavior({_mutatedom:function(root){var $root=$(root);$root.find('div.tabbed-content').each(function(){$(this).removeClass('tabbed-content').addClass('sub-tabbed-content');});$root.find('div.tab-section').each(function(){$(this).removeClass('tab-section').addClass('subTab-section');});$root.find('ul.tabnav').each(function(){$(this).removeClass('tabnav').addClass('sub-tabnav');});$root.find('a.tab').each(function(){var $this=$(this);var strSubTabLabel=$this.text();$this.removeClass('tab').addClass('sub-tab').html(strSubTabLabel);});},initComponent:function(attributes,componentDOM){this._mutatedom(this._componentDOM);},getSource:function(customElementAttributes){customElementAttributes.linkbindlistner='arguments[1].parents(\'.tab-section\').getComponent().linkbindlistner(arguments[0], arguments[1]);';var currentState=customElementAttributes.state;if(currentState==='selected'){currentState='current';}else if(currentState==='hidden'){currentState='u-hide';}else if(currentState!=='disabled'){currentState='';}
customElementAttributes.tabContentState=currentState;return this.getHTML('mca-tab.ejs',{'model':customElementAttributes});},getConfig:function(){return{'name':{name:'Tab name',value:'UNDEFINED_TAB_NAME',type:'string'},state:{name:'Tab state',value:'',type:'select',options:{selected:'Show tab',hidden:'Hide tab',disabled:'Disable tab'}},text:{content:true,name:'Tab Content',value:'',type:'string'},id:{name:'ID',value:'',type:'string',validation:{message:'ID must be unique.',unique:true}},'class':{name:'Class',value:'',type:'string'},tabindex:{name:'Tab index',value:'0',type:'string',validation:{integer:true,unique:false,message:'Tab index must be a number.'}},'icon':{name:'Icon',value:'',type:'select',options:new icon().getConfig().type.options}};}});return definition.getComponentConstructor();});define('barclays/mca/components/templates/bdl/tabs/mca-tabs',function(){return function anonymous(locals,escape,include,rethrow){rethrow=rethrow||function rethrow(err,str,filename,lineno){var lines=str.split('\n');var start=Math.max(lineno-3,0);var end=Math.min(lines.length,lineno+3);var context=lines.slice(start,end).map(function(line,i){var curr=i+start+1;return(curr==lineno?' >> ':'    ')
+curr
+'| '
+line;}).join('\n');err.path=filename;err.message=(filename||'ejs')+':'
+lineno+'\n'
+context+'\n\n'
+err.message;throw err;};escape=escape||function(markup){return markup==undefined?'':String(markup).replace(_MATCH_HTML,encode_char);};var _ENCODE_HTML_RULES={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&#34;","'":"&#39;"},_MATCH_HTML=/[&<>'"]/g;function encode_char(c){return _ENCODE_HTML_RULES[c]||c;};;var __line=1,__lines="<div class=\"tab-section <%= model[\"class\"] %>\" >\n<div role=\"tablist\" id=\"<%= model.id %>\" class=\"tab <%= model.type %>\"></div>\n<div class=\"tab-content\">\n<%- model.content %>\n</div>\n</div>",__filename=undefined;try{var __output=[],__append=__output.push.bind(__output);with(locals||{}){;__append("<div class=\"tab-section ");__append(escape(model["class"]));__append("\" >\n<div role=\"tablist\" id=\"");__line=2;__append(escape(model.id));__append("\" class=\"tab ");__append(escape(model.type));__append("\"></div>\n<div class=\"tab-content\">\n");__line=4;__append(model.content);__append("</div>\n</div>");__line=6}
return __output.join("");}catch(e){rethrow(e,__lines,__filename,__line);}}});define('barclays/mca/components/collection/bdl/tabs',['barclays/mca/components/libs/common/extend/bdlApi','barclays/mca/components/collection/bdl/tab'],function(api,tab){var definition=api.createComponent('tabs');definition.usePrebuiltBdlStyles();definition.declareBehavior({_attributes:null,_componentDOM:null,_tabsCount:-1,_childElmCounter:0,_tabsErrorHandler:function(errorCode){var errors={STATE_VIOLATION:'<mca-tabs> does not allow more than 1 <mca-tab> with state="selected".',INVALID_SELECTION:'Atleast 1 <mca-tab> must have state="selected".',MISSING_DEPENDENCY:'Missing tabs dependency, add bs-tabs from vendor plugins.'};throw new Error(errors[errorCode]);},_mutateTabNodeList:function(rootElement,rootID){var $container=$(rootElement);var $tabContent=$container.find('div.tab-content');try{$container.find('.tabbed-content').each(function(index,el){var currentSubTabElements=$(el).find('.sub-tabbed-content.current').length;var subTabElements=$(el).find('.sub-tabbed-content').length;if(currentSubTabElements>1){throw('STATE_VIOLATION');}else if(subTabElements>0&&currentSubTabElements!==1){throw('INVALID_SELECTION');}});var currentTabElements;if($tabContent.first().children('div.tabbed-content.current').length===0){currentTabElements=$tabContent.first().children().children('div.tabbed-content.current').length;}else{currentTabElements=$tabContent.first().children('div.tabbed-content.current').length;}
var tabElements=$container.find('.tab').length;if(currentTabElements>1){throw('STATE_VIOLATION');}else if(tabElements>0&&currentTabElements!==1){throw('INVALID_SELECTION');}}catch(ecode){this._tabsErrorHandler(ecode);}
var $tabList;if($tabContent.first().children('div.tabbed-content').length===0){$tabList=$tabContent.first().children().children('div.tabbed-content').children('a.tab');}else{$tabList=$tabContent.first().children('div.tabbed-content').children('a.tab');}
$tabList.each(function(index,element){var $this=$(element);$this.attr('href','#'+$this.attr('id').split('__')[0]).attr('role','tab').addClass('tab-link');if(!$this.hasClass('disabled')){$this.attr('data-toggle','tab');}
$container.find('#'+rootID).append($this);});var $subTabList=$container.find('div.tab a.sub-tab');$subTabList.each(function(index,element){var $this=$(element);var strPanelHeading='<a href="javascript:void(0);" tabindex="-1">'.concat($this.text(),'</a>');$this.html(strPanelHeading);$this.attr('href','#'+$this.attr('id').split('__')[0]).attr('data-toggle','tab').attr('role','tab').addClass('tab-link');});this._updateDOM($container);this._addArrowKeyListener($container);this._activate($container);},initComponent:function(customElementAttributes,componentDOM){if(typeof $.fn.tab==='undefined'){this._tabsErrorHandler(MISSING_DEPENDENCY);}
this._componentDOM=componentDOM[0];this._attributes=customElementAttributes;if(this._tabsCount<0){this._tabsCount=this._componentDOM.find('div.tab-content').first().children().length;}},_updateDOM:function($container){$container.find('a.tab').removeClass('tab');$container.find('div.tabbed-content').addClass('tab-panel');$container.find('div.current').addClass('active');$container.find('a.current').addClass('active');},_activate:function($container){$container.find('div.tab a').on('shown.bs.tab',function(e){$(this).closest('div.tab').find('a').removeClass('active');$(this).addClass('active');});},_addArrowKeyListener:function($container){var tabElem=$container.find('div.tab a.tab-link');var _listTabArr;tabElem.focus(function(){var _listObj=$(this).closest('div.tab');var _idx=0;_listTabArr=[];_listObj.find('a').each(function(index,elm){if(!$(elm).hasClass('disabled')){_listTabArr.push($(elm));$(elm).data('newIndex',_idx++);}});});tabElem.on('keydown',function(e){var key=e.keyCode?e.keyCode:e.which;var currentElemIndex=$(this).data('newIndex');if(key===13){e.preventDefault();}
if(key===39){currentElemIndex=(currentElemIndex>=_listTabArr.length-1)?0:currentElemIndex+1;_listTabArr[currentElemIndex].focus().trigger('click');}else if(key===37){currentElemIndex=(currentElemIndex<=0)?_listTabArr.length-1:currentElemIndex-1;_listTabArr[currentElemIndex].focus().trigger('click');}else{return;}});},linkbindlistner:function(currentlink,linkDOM){this._childElmCounter++;if(this._childElmCounter>=this._tabsCount){this._mutateTabNodeList(this._componentDOM,this._attributes.id);}},_getTabsType:function(customElementAttributes){var tabsTypeMapping={standard:'',section:'tab-open',page:'tab-page'};if(customElementAttributes['type']in this.getConfig()['type'].options){return tabsTypeMapping[customElementAttributes['type']];}
return'';},getSource:function(customElementAttributes){customElementAttributes.type=this._getTabsType(customElementAttributes);return this.getHTML('mca-tabs.ejs',{'model':customElementAttributes});},getConfig:function(){return{text:{content:true,name:'Tabs Content',value:'',type:'string'},type:{name:'Tab Type',type:'select',options:{standard:'Standard tab',section:'Section tab',page:'Page tab'}},'class':{name:'Class',value:'',type:'string'},id:{name:'ID',value:'',type:'string',mandatory:true,validation:{message:'ID must be unique.',unique:true}},tabindex:{name:'Tab index',value:'0',type:'string',validation:{integer:true,unique:false,message:'Tab index must be a number.'}}};}});return definition.getComponentConstructor();});define('barclays/mca/components/bundles/bdl-tab',['barclays/mca/components/collection/bdl/tab','barclays/mca/components/collection/bdl/tabs'],function(){});